//Regulator oswietlenia sterowany pilotem
//Autor programu: Zbigniew Hajduk, 2004
#include <reg51.h>
typedef unsigned char uchar;


sbit   outp=P1^7;
sbit   outp2=P1^0;

void BusyCheck(void);
void LCDSendByte(uchar,bit);
void LCDinit (void);
void clrscr (void);
void gotoxy (uchar,uchar);
void LCDputs (char*);
void LCDputch(char);
void delay(unsigned int);
void moveCGRAM (uchar,char,char);


static void printhex(uchar i,bit f);

void set400ms(void);
void set50ms(void);
void set115ms(void);
void set150ms(void);


unsigned int irdata;
unsigned int rc5code;
bit rdy,Toggle,mT;
unsigned int getrc5(void);


void main(void)
{  char mcmd,cmd,addr,master_addr,on_cmd,mcmd2;

      TMOD=0x11; TR0=1; TR1=1;
      TL0=0; TH0=0;
      IP=1;
      IT0=1;
      EX0=1; EA=1;

       P3=0xff; P1=0xfd;

     outp=1; outp2=0; on_cmd=mcmd2=255;
     rdy=0;
     set50ms(); while(!TF0); TF0=0;
     outp2=1; set115ms(); while(!TF0); TF0=0; outp2=0;


     while(1)
     {

       if(rdy)
       {
         rdy=0;
         irdata=rc5code;
         on_cmd=mcmd=cmd=irdata&0x003f;
         master_addr=(irdata>>6)&0x001f;
         Toggle=irdata&0x0800;
         mT=Toggle;
         break;
       }

     }
     outp=0; outp2=1; set115ms(); while(!TF0); TF0=0; outp=1; outp2=0;
      set400ms(); while(!TF0); TF0=0;
     outp2=1; set115ms(); while(!TF0); TF0=0; outp2=0;

     while(1)
     {

         if(TF0)
         {
             outp=1; outp2=0; TF0=0;
         }

        if(rdy)
        {
          rdy=0;
          irdata=rc5code;
          addr=(irdata>>6)&0x001f;
          if(addr!=master_addr) continue;
          Toggle=irdata&0x0800;
          cmd=irdata&0x003f;

          if(cmd==0x20||cmd==0x21)
          {   if(outp2&&mcmd!=0x20&&mcmd!=0x21)
              {  outp2=0; set50ms(); while(!TF0); TF0=0;
              }
              if(Toggle!=mT&&cmd==mcmd2)
              {
                 outp2=1; set400ms(); while(!TF0); TF0=0; outp2=0;
                 set50ms(); while(!TF0); TF0=0;
                 outp2=1; set400ms();
              }
              else
              {   outp2=1;
                  set400ms();
              }

             mcmd2=cmd;
          }
          else
          if(cmd==0x3b)
          {
               outp2=1;
               set400ms();

          }
          else
          if(cmd==0x39||cmd==0x3a||cmd==0x0c||cmd==0x11||cmd==0x10)
          {  if(cmd==0x0c)
             {
                  if(Toggle!=mT)
                  { outp2=1; set115ms(); while(!TF0); outp2=0; }
             }
             else
             if(cmd!=on_cmd)
             { outp=0; outp2=1; set115ms(); while(!TF0); outp=1; outp2=0;
               on_cmd=cmd;
             }
          }


           mcmd=cmd;
           mT=Toggle;

        }
     }

}



void delay(unsigned int a)
{
   while (a--);
}


void int_t0(void) interrupt 1 using 2
{

}


void set400ms(void)
{  TF0=0; TH0=195; TL0=0; TR0=1;
}

void set50ms(void)
{  TF0=0; TH0=247; TL0=0; TR0=1;
}

void set115ms(void)
{  TF0=0; TH0=237; TL0=0; TR0=1;
}


void set150ms(void)
{  TF0=0; TH0=234; TL0=0; TR0=1;
}