                NAME itt

iram            segment data

outbit          BIT     P3.5


ittseg          segment code


                public  _ittgen

                rseg    iram
delay:          ds      1


                rseg  ittseg
Delay5us:
                nop
                nop
                nop
                djnz    delay,Delay5us
                ret

Pulse:          mov     delay,#1
                setb    outbit
                lcall   Delay5us
                clr     outbit
                ret

_ittgen:        clr     EA
                mov     a,r7
                rl      a
                rl      a
                mov     r7,a
                mov     a,r6
                rl      a
                rl      a
                rl      a
                rl      a
                mov     r6,a
                lcall   Pulse
                mov     delay,#60
                lcall   Delay5us
                lcall   Pulse  ; pre pulse
                mov     delay,#17
                lcall   Delay5us
                mov     a,r6
                mov     r0,#4
                lcall   Pulse  ;start pulse
a1:             mov     delay,#17
                rlc     a
                jnc     n1
                mov     delay,#37
n1:             lcall   Delay5us
                lcall   Pulse
                djnz    r0,a1
                mov     a,r7
                mov     r0,#6
a2:             mov     delay,#17
                rlc     a
                jnc     n2
                mov     delay,#37
n2:             lcall   Delay5us
                lcall   Pulse
                djnz    r0,a2
                mov     delay,#60
                lcall   Delay5us
                lcall   Pulse
                setb    EA
                ret


                end